# STM32L476G-EVAL Evaluation board

## Overview

The STM32L476G-EVAL Evaluation board is designed as a complete demonstration and development platform for the STMicroelectronics Arm® Cortex®-M4 core-based STM32L476ZG microcontroller, with 1 Mbyte of flash memory and 128 Kbytes of SRAM.

The full range of hardware features available on the board helps users to enhance their application development by an evaluation of all the peripherals (such as USB, USART, digital microphones, ADC and DAC, dot-matrix TFT LCD, LCD glass module, IrDA (supported up to version MB1144 C-01 of the board), LDR, SRAM, NOR flash memory device, Quad-SPI flash memory device, microSD™ card, sigma-delta modulators, smartcard with SWP, CAN transceiver, EEPROM, RF-EEPROM).

The daughterboard and extension connectors provide an easy way to connect a daughterboard or wrapping board for the user's specific application.

ST-LINK/V2-1 is integrated into the board, as the embedded in-circuit debugger and programmer for the STM32 MCU and USB Virtual COM port bridge.

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um1855-evaluation-board-with-stm32l476zg-mcu-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32L476ZG microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32l476zg.html)
- [STM32L476G-EVAL board](https://www.st.com/en/evaluation-tools/stm32l476g-eval.html)
- [User manual](https://www.st.com/resource/en/user_manual/um1855-evaluation-board-with-stm32l476zg-mcu-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/resource/en/data_brief/stm32l476g-eval.pdf)
- [Schematic](https://www.st.com/resource/en/schematic_pack/mb1144-default-b02-schematic.pdf)
